# TP2AConditioningStudents.py
"""---------------------------------------------------
Condition number of a matrix : a classical example
---------------------------------------------------"""
import numpy as np
from numpy import linalg as LA

A = np.array([[10, 7, 8, 7],
              [7, 5, 6, 5],
              [8, 6, 10, 9],
              [7, 5, 9, 10]])
b = np.array([32, 23, 33, 31])
x  = np.ones(4)
np.dot(A,x)     # array([ 32.,  23.,  33.,  31.])
# condition number of matrix A :
LA.cond(A)      # 2984.0927016757 

# Perturbation of second member b :
be = np.array([32.01, 22.99, 33.01, 30.99])
xe1 = np.linalg.solve(A,be)          # xe1 = np.array([1.82, -0.36, 1.35, 0.79])
np.dot(A,xe1)                        # we find again vector be
REb = LA.norm(be - b) / LA.norm(b)   # relative error on second member b
REx1 = LA.norm(xe1 - x) / LA.norm(x) # relative error on solution xe1
REx1 / REb                           # 2460.5672364315219
             
# Perturbation of matrix A :
Ae = np.array([[10, 7, 8.1, 7.2],
              [7.08, 5.04, 6, 5],
              [8, 5.98, 9.89, 9],
              [6.99, 4.99, 9, 9.98]])
xe2 = np.linalg.solve(Ae,b)          # xe2 = np.array([-81, 137, -34, 22])
np.dot(Ae,xe2)                       # array([ 32.,  23.,  33.,  31.])
REA = LA.norm(Ae - A) / LA.norm(A)   # relative error on matrix A
REx2 = LA.norm(xe2 - x) / LA.norm(x) # relative error on solution xe2
REx2 / REA                           # 9391.5899625844304
# BUT the correct way to evaluate the relative error is the following :
REx2 = LA.norm(xe2 - x) / LA.norm(xe2) # relative error on solution xe2
REx2 / REA                           # 114.37435170771546  

"""
QUESTIONS :
    1) comment lines 24 and 35 & 38 of this script
    2) explicit the norm used by numpy.linalg.norm
    3) determine two different matrices of size (6,6), 
        with at least two coefficients equal to 10^6
        whose condition number is equal to 1
        Justify your answer : which result from Chapter 2 are you using?
"""
