# TP3ALagrange1DStudents.py
"""
TP3A (1D)
Interpolation in Lagrange basis
Two parts :
    - display of Lagrange polynomials
    - uniform interpolation of two test functions
      and analysis according to the degree
"""

"""--------------------
Test functions
--------------------"""
def ftest1(t) :
    y = (np.cos(1-t**2)) * np.exp(-t**2 + 3*t - 2)
    return y

def ftest2(t) :
    y = 1. / (1. + 25. * t**2)
    return y

def LagrangePoly(k,xi,t):
    """ Determination of the k-th Lagrange polynomial L_k(x) 
        associated with points xi,
        for a vector t of numerical values
        Input:
            k = integer designing the Lagrange polynomial to be evaluated
            xi = vector of points defining the Lagrange polynomial
            t = vector of real values (sampling of an interval [a,b])
        Output:
            y = L_k(t)
    """
    n = np.size(xi) # degree + 1
    y = np.ones(np.size(t))
    for j in range(n):
        ------
        ------
    return y

"""--------------------------------------
MAIN PROGRAM
--------------------------------------"""
import numpy as np
import matplotlib.pyplot as plt
plt.clf()

#----------------------------------------------------------
# PART 1:
# LAGRANGE POLYNOMIALS L_k(t)
a = -2
b = 4
n = 6 # degree + 1 = number of interpolation points
t  = np.linspace(a,b,200)
# UNIFORM DATA :
p1 = plt.subplot(211)
xi = np.linspace(a,b,n)
plt.plot(xi,0*xi,'ob',ms=8)  # plot points (xi,0)
for k in range(n):
    ------
    ------
plt.legend(loc='best')
plt.grid(True)
# NON UNIFORM DATA :
p2 = plt.subplot(212)
xi = np.array([-2, -1 , -0.5, 1.5, 3.5, 4 ])
n = np.size(xi)
plt.plot(xi,0*xi,'ob',ms=8)  # plot points (xi,0)
for k in range(n):
    ------
    ------ 
plt.legend(loc='best')
plt.grid(True)

#----------------------------------------------------------
# PART 2:
# INTERPOLATION OF FUNCTION ftest1 IN THE LAGRANGE BASIS
plt.figure(2)
# Plot of function f :
a = 0
b = 4
t = np.linspace(a,b,200)
y = ftest1(t)
plt.plot(t,y,'--b') 
plt.legend(['function f'], loc='best')
plt.plot([a,b], [0,0],'k') # x-axis
plt.grid(True)

# Interpolation points (uniform) :
n = 20
xk =  np.linspace(a,b,n+1)
yk = ftest1(xk)
plt.plot(xk,yk,'ob',ms=10) 

# Determination of the interpolation polynomial of data xi,yi
p = np.zeros(np.size(t))
for k in range(n+1):
    ------
plt.plot(t,p,'r',lw=1) 

#----------------------------------------------------------
# PART 2bis:
# INTERPOLATION OF FUNCTION ftest2 IN THE LAGRANGE BASIS
plt.figure(3)
# Plot of function f :
a = -1
b = 1
t = np.linspace(a,b,200)
y = ftest2(t)
------
------
------

# Interpolation points (uniform) :
n = 8
------
------
------

# Determination of the interpolation polynomial of data xi,yi
p = np.zeros(np.size(t))
for k in range(n+1):
    ------
plt.plot(t,p,'r',lw=1) 

